Unit Main;
{ ========================================================================== }
{ =   Lynx Tecnologia Eletrnica Ltda.                                     = }
{ =   Projeto:   Windows WDM Drivers - CAD12/56         Data: 20/jan/2000  = }
{ =   Programa:  Teste do driver da CAD12/56 para Windows 98.              = }
{ =   Mdulo:    Main                                                      = }
{ =   Autor:     Lauro                                                     = }
{ =   Descrio: Window principal do programa.                             = }
{ =   Verso:    2.0                                                       = }
{ ========================================================================== }

{-------------------------  Descrio da Interface  -------------------------}
Interface

Uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
     StdCtrls, Buttons, Menus, ExtCtrls,
     TestAD, TestIRQ, ComCtrls, Grids;

{ ===================================================== }
{ =               Declarao de tipos                 = }
{ ===================================================== }

Type
  TMainForm = class(TForm)
    panBack     : TPanel;
    StatusBar   : TStatusBar;
    MainMenu    : TMainMenu;
    panControl  : TPanel;
    btOpen      : TBitBtn;
    btClose     : TBitBtn;
    panTiControl: TPanel;
    panTest     : TPanel;
    panTiTest   : TPanel;
    btTestAD    : TBitBtn;
    btTestIRQ   : TBitBtn;
    Arquivo1    : TMenuItem;
    Sair1       : TMenuItem;
    btTestDIO: TBitBtn;
    Procedure FormCreate (Sender: TObject);
    Procedure FormClose (Sender: TObject; var Action: TCloseAction);
    Procedure btCloseClick (Sender: TObject);
    Procedure btOpenClick (Sender: TObject);
    Procedure btTestADClick (Sender: TObject);
    Procedure btTestIRQClick (Sender: TObject);
    Procedure Sair1Click (Sender: TObject);
    procedure btTestDIOClick(Sender: TObject);
  private
    { Private declarations }
    fOpen   : boolean;          { Indica se o VxD foi carregado }
    fInitCAD: boolean;          { Indica se o ADS2000 foi iniciado }
    Procedure FinalizaDriver;
    Procedure UpdateCommands;
  public
    { Public declarations }
  end;


{ ===================================================== }
{ =                Variveis globais                  = }
{ ===================================================== }

  Var MainForm: TMainForm;


{-------------------------  Descrio da Implementao ----------------------}
Implementation
  Uses WDMapi, TestDIO;

{$R *.DFM}

{ ========================================================================== }
{ =                   Implementao do objeto TMainForm                    = }
{ ========================================================================== }

{---------------------------------- TMainForm: Trata criao do formulrio --}
Procedure TMainForm.FormCreate (Sender: TObject);
  Var i   : smallint;
      sAux: string;
begin
  fOpen := false;
  UpdateCommands;
end;

{------------------------------- TMainForm: Trata fechamento do formulrio --}
Procedure TMainForm.FormClose (Sender: TObject; var Action: TCloseAction);
begin
  FinalizaDriver;
end;

{----------------- TMainForm: Trata comando para fechar o acesso ao driver --}
Procedure TMainForm.btCloseClick (Sender: TObject);
begin
  FinalizaDriver;
  StatusBar.Panels.Items [1].Text := '';
  UpdateCommands;
end;

{------------------------------ TMainForm: Abre o acesso ao drive WDM_1256 --}
Procedure TMainForm.btOpenClick (Sender: TObject);
begin
  fOpen := (WDM_Open = 0);
  if  fOpen
  then begin
    if  WDM_DriverInfo (DriverInfo)  then
      StatusBar.Panels.Items [0].Text := 'WDM_1256 ' +
                   IntToStr (DriverInfo.VersionHigh) + '.' +
                   IntToStr (DriverInfo.VersionLow);
  end;
  UpdateCommands;
end;

{------------------------ TMainForm: Trata comando de teste do E/S digital --}
Procedure TMainForm.btTestDIOClick (Sender: TObject);
begin
  if (DriverInfo.nDiPorts <= 0) and (DriverInfo.nDiPorts <= 0) then
    MessageDlg ('Placa no possui suporte para E/S digital!',
                mtWarning, [mbOk], 0)
  else begin
    dlgTestDIO := TdlgTestDIO.Create (Self);
    dlgTestDIO.ShowModal;
    dlgTestDIO.Destroy;
  end;
end;

{------------------------ TMainForm: Trata comando de teste do A/D por WFF --}
Procedure TMainForm.btTestADClick (Sender: TObject);
begin
  if (DriverInfo.nAiChannels <= 0) and (DriverInfo.nAoChannels <= 0) then
    MessageDlg ('Placa no possui suporte para E/S analgica!',
                mtWarning, [mbOk], 0)
  else begin
    dlgTestAD := TdlgTestAD.Create (Self);
    dlgTestAD.tmrUpdate.Enabled := true;
    dlgTestAD.ShowModal;
    dlgTestAD.Destroy;
  end;
end;

{---------- TMainForm: Trata comando de teste de aquisio por interrupo --}
Procedure TMainForm.btTestIRQClick (Sender: TObject);
begin
  if (DriverInfo.nAiChannels <= 0)  then
    MessageDlg ('Placa no possui suporte para entrada analgica!',
                mtWarning, [mbOk], 0)
  else begin
    dlgTestIRQ := TdlgTestIRQ.Create (Self);
    dlgTestIRQ.ShowModal;
    dlgTestIRQ.Destroy;
  end;
end;

{---------------------------------- TMainForm: Finaliza o acesso ao driver --}
Procedure TMainForm.FinalizaDriver;
begin
  if  fOpen
  then begin
    WDM_Close;           { Fecha o acesso ao driver }
    fOpen := false;
  end;
end;

{----------------------------------------- TMainForm: Finaliza a aplicao --}
Procedure TMainForm.Sair1Click (Sender: TObject);
begin
  Close;
end;

{------------------------------ TMainForm: Atualiza habilitao dos botes --}
Procedure TMainForm.UpdateCommands;
begin
  btOpen.Enabled    := not fOpen;
  btClose.Enabled   := fOpen;
  btTestDIO.Enabled := fOpen;
  btTestAD.Enabled  := fOpen;
  btTestIRQ.Enabled := fOpen;
end;

end.
