Attribute VB_Name = "WDMapi"
' ============================================================================
' =   Lynx Tecnologia Eletrnica Ltda.                                       =
' =   Projeto:   Drivers / Windows 98                     Data: 21/jan/2000  =
' =   Programa:  Teste do driver WDM_1256 da CAD12/56 para Windows 98.       =
' =   Mdulo:    WDMapi                                                      =
' =   Autor:     Lauro                                                       =
' =   Descrio: Acesso s primitivas do driver WDM_1256.SYS                 =
' =   Verso:    2.0                                                         =
' ============================================================================

' =====================================================
' =              Declarao de constantes             =
' =====================================================

  '----------------------------------------- ieXXXX: Interrupt error status --
  Public Const ieNoError = 0            ' Nenhum erro
  Public Const ieIntOverrun = 1         ' Overrun de interrupo
  Public Const ieAD_Error = 2           ' Error no conversor A/D
  Public Const ieBufOverrun = 3         ' Overflow no buffer de aquisio
  Public Const ieDriver = 100           ' Erro de acesso ao driver
  Public Const ieAcqStop = 101          ' Aquisio no est ativa
  Public Const ieBufSize = 102          ' Dimenso errada do buffer

  '------------------------- seXXXX: Cdigo de erro da WDM_StartAcquisition --
  Public Const seNoError = 0            ' No error
  Public Const seNoSignal = 1           ' Nenhum sinal habilitado



' ============================================================================
' =                         Declarao de Tipos                              =
' ============================================================================

  Type TpAiRange
    Range(0 To 15) As Single
  End Type
  
  Public Const cBufSize = 16384   ' Tamanho do buffer em amostras
  Type TpUserBuf
    Buffer(0 To cBufSize - 1) As Integer
  End Type



' ============================================================================
' =          Primitivas do driver WDM_1256.SYS acessados pela DLL            =
' ============================================================================

'----------------------------------------  Abre o acesso ao driver WDM_1256 --
Declare Function WDM_Open Lib "WDM_1256.DLL" () As Long

'-------------------------------------------------- Fecha o driver WDM_1256 --
Declare Sub WDM_Close Lib "WDM_1256.DLL" ()

'------------------------------------------------- Obtm a verso do driver --
Declare Function WDM_GetVersion Lib "WDM_1256.DLL" _
        (VersionHigh As Byte, VersionLow As Byte) As Byte

'--------------------------------------- Obtm os recursos de E/S analgica --
Declare Function WDM_GetAIO_Caps Lib "WDM_1256.DLL" _
        (TmrClock As Single, nAiChannels As Integer, nAoChannels As Integer, _
         nAiRange As Integer, AiRange As TpAiRange) As Byte

'----------------------------------------- Obtm os recursos de E/S digital --
Declare Function WDM_GetDIO_Caps Lib "WDM_1256.DLL" _
        (nDiPorts As Integer, nBitsDI As Integer, _
         nDoPorts As Integer, nBitsDO As Integer) As Byte

'------------------------------------------------ Limpa a memria de canais --
Declare Sub WDM_Clear_CM Lib "WDM_1256.DLL" ()

'---------------------------------------- Insere canal na memria de canais --
Declare Function WDM_Insert_AI_CM Lib "WDM_1256.DLL" _
        (ByVal Channel As Byte, ByVal iRange As Byte) As Long

'------------------------------ Insere entrada digital na memria de canais --
Declare Function WDM_Insert_DI_CM Lib "WDM_1256.DLL" _
        (ByVal Group As Byte, ByVal iRange As Byte) As Long

'---------------------------------- Preparao da aquisio por interrupo --
Declare Function WDM_AcquisitionSetup Lib "WDM_1256.DLL" _
        (ByVal SampleFreq As Single, ErrorCode As Long) As Long

'--------------------------------------- Inicia a aquisio por interrupo --
Declare Sub WDM_StartAcquisition Lib "WDM_1256.DLL" ()

'------------------------------------- Finaliza a aquisio por interrupo --
Declare Sub WDM_StopAcquisition Lib "WDM_1256.DLL" ()

'----------------------------- Leitura das amostras aquisitadas pelo driver --
Declare Function WDM_GetAcquiredDataVB Lib "WDM_1256.DLL" _
        (ieStatus As Long, nSamples As Long, nSampGot As Long, _
         iLast As Long, UserBuf As TpUserBuf) As Long

'----------------------------------------------- Programa ganho da CAD12/56 --
Declare Function WDM_SetAiRange Lib "WDM_1256.DLL" _
        (ByVal iRange As Byte) As Long

'----------------------------------------- Le entrada analgica da CAD12/56 --
Declare Function WDM_ReadAi Lib "WDM_1256.DLL" _
        (ByVal Channel As Byte, Value As Integer) As Long

'----------------------------------- Escreve em sada analgica da CAD12/56 --
Declare Function WDM_WriteAo Lib "WDM_1256.DLL" _
        (ByVal Channel As Byte, ByVal Value As Integer) As Long

'------------------------------------------- Le entrada digital da CAD12/56 --
Declare Function WDM_ReadDI Lib "WDM_1256.DLL" _
        (ByVal Group As Byte, Value As Integer) As Long

'------------------------------------- Escreve em sada digital da CAD12/56 --
Declare Function WDM_WriteDO Lib "WDM_1256.DLL" _
        (ByVal Group As Byte, ByVal Value As Integer) As Long

Public fMainForm As frmMain


Sub Main()
    Set fMainForm = New frmMain
    fMainForm.Show
End Sub



